jjb: use tox to run lttng-analyses build
[lttng-ci.git] / scripts / lttng-tools / build.sh
index b557c4143bee859b586163206d82c9965f015a9d..e2bf145d3c407db436d7c223103fb682d6a01ae3 100755 (executable)
@@ -1,6 +1,6 @@
-#!/bin/bash -xue
+#!/bin/bash -exu
 #
-# Copyright (C) 2015 - Jonathan Rajotte-Julien <jonathan.rajotte-julien@efficios.com>
+# Copyright (C) 2016 - Jonathan Rajotte-Julien <jonathan.rajotte-julien@efficios.com>
 #                      Michael Jeanson <mjeanson@efficios.com>
 #
 # This program is free software: you can redistribute it and/or modify
 # along with this program.  If not, see <http://www.gnu.org/licenses/>.
 
 # Version compare functions
+vercomp () {
+    set +u
+    if [[ "$1" == "$2" ]]; then
+        return 0
+    fi
+    local IFS=.
+    local i ver1=($1) ver2=($2)
+    # fill empty fields in ver1 with zeros
+    for ((i=${#ver1[@]}; i<${#ver2[@]}; i++)); do
+        ver1[i]=0
+    done
+    for ((i=0; i<${#ver1[@]}; i++)); do
+        if [[ -z ${ver2[i]} ]]; then
+            # fill empty fields in ver2 with zeros
+            ver2[i]=0
+        fi
+        if ((10#${ver1[i]} > 10#${ver2[i]})); then
+            return 1
+        fi
+        if ((10#${ver1[i]} < 10#${ver2[i]})); then
+            return 2
+        fi
+    done
+    set -u
+    return 0
+}
+
 verlte() {
-    [  "$1" = "`printf '%s\n%s' $1 $2 | sort -V | head -n1`" ]
+    vercomp "$1" "$2"; local res="$?"
+    [ "$res" -eq "0" ] || [ "$res" -eq "2" ]
 }
 
 verlt() {
-    [ "$1" = "$2" ] && return 1 || verlte $1 $2
+    vercomp "$1" "$2"; local res="$?"
+    [ "$res" -eq "2" ]
 }
 
 vergte() {
-    [  "$1" = "`printf '%s\n%s' $1 $2 | sort -V | tail -n1`" ]
+    vercomp "$1" "$2"; local res="$?"
+    [ "$res" -eq "0" ] || [ "$res" -eq "1" ]
 }
 
 vergt() {
-    [ "$1" = "$2" ] && return 1 || vergte $1 $2
+    vercomp "$1" "$2"; local res="$?"
+    [ "$res" -eq "1" ]
+}
+
+verne() {
+    vercomp "$1" "$2"; local res="$?"
+    [ "$res" -ne "0" ]
 }
 
 
 # Create build directory
-rm -rf $WORKSPACE/build
-mkdir -p $WORKSPACE/build
+rm -rf "$WORKSPACE/build"
+mkdir -p "$WORKSPACE/build"
 
 # liburcu
 URCU_INCS="$WORKSPACE/deps/liburcu/build/include/"
@@ -78,6 +114,19 @@ solaris11)
     export PATH="$PATH:/usr/perl5/bin"
     ;;
 
+macosx)
+    MAKE=make
+    TAR=tar
+    NPROC="getconf _NPROCESSORS_ONLN"
+    BISON="bison"
+    YACC="$BISON -y"
+    RUN_TESTS="no"
+
+    export PATH="/opt/local/bin:/opt/local/sbin:/usr/local/bin:/usr/bin:/bin:/usr/sbin:/sbin"
+    export CFLAGS="-I/opt/local/include"
+    export LDFLAGS="-L/opt/local/lib"
+    ;;
+
 *)
     MAKE=make
     TAR=tar
@@ -104,6 +153,7 @@ esac
 
 # Get source version from configure script
 eval `grep '^PACKAGE_VERSION=' ./configure`
+PACKAGE_VERSION=`echo "$PACKAGE_VERSION"| sed 's/\-pre$//'`
 
 
 # Export build flags
@@ -164,7 +214,7 @@ python-agent)
 
 relayd-only)
     echo "Build relayd only"
-    CONF_OPTS="--disable-bin-lttng --disable-bin-lttng-consumerd --disable-bin-lttng-crash --disable-bin-lttng-sessiond --disable-extras $NO_UST"
+    CONF_OPTS="--disable-bin-lttng --disable-bin-lttng-consumerd --disable-bin-lttng-crash --disable-bin-lttng-sessiond --disable-extras --disable-man-pages $NO_UST"
     ;;
 
 *)
@@ -186,57 +236,57 @@ case "$build" in
     oot)
         echo "Out of tree build"
         BUILD_PATH=$WORKSPACE/oot
-        mkdir -p $BUILD_PATH
-        cd $BUILD_PATH
-        MAKE=$MAKE BISON="$BISON" YACC="$YACC" CFLAGS="$CFLAGS" $WORKSPACE/configure --prefix=$PREFIX $CONF_OPTS
+        mkdir -p "$BUILD_PATH"
+        cd "$BUILD_PATH"
+        MAKE=$MAKE BISON="$BISON" YACC="$YACC" CFLAGS="$CFLAGS" "$WORKSPACE/configure" --prefix="$PREFIX" $CONF_OPTS
         ;;
 
     dist)
         echo "Distribution out of tree build"
-        BUILD_PATH=`mktemp -d`
+        BUILD_PATH="`mktemp -d`"
 
         # Initial configure and generate tarball
         MAKE=$MAKE BISON="$BISON" YACC="$YACC" CFLAGS="$CFLAGS" ./configure $CONF_OPTS --enable-build-man-pages
         $MAKE dist
 
-        mkdir -p $BUILD_PATH
-        cp *.tar.* $BUILD_PATH/
-        cd $BUILD_PATH
+        mkdir -p "$BUILD_PATH"
+        cp ./*.tar.* "$BUILD_PATH/"
+        cd "$BUILD_PATH"
 
         # Ignore level 1 of tar
-        $TAR xvf *.tar.* --strip 1
+        $TAR xvf ./*.tar.* --strip 1
 
-        MAKE=$MAKE BISON="$BISON" YACC="$YACC" CFLAGS="$CFLAGS" $BUILD_PATH/configure --prefix=$PREFIX $CONF_OPTS
+        MAKE=$MAKE BISON="$BISON" YACC="$YACC" CFLAGS="$CFLAGS" "$BUILD_PATH/configure" --prefix="$PREFIX" $CONF_OPTS
         ;;
 
     *)
         BUILD_PATH=$WORKSPACE
         echo "Standard tree build"
-        MAKE=$MAKE BISON="$BISON" YACC="$YACC" CFLAGS="$CFLAGS" $WORKSPACE/configure --prefix=$PREFIX $CONF_OPTS
+        MAKE=$MAKE BISON="$BISON" YACC="$YACC" CFLAGS="$CFLAGS" "$WORKSPACE/configure" --prefix="$PREFIX" $CONF_OPTS
         ;;
 esac
 
 # BUILD!
-$MAKE -j `$NPROC` V=1
+$MAKE -j "`$NPROC`" V=1
 $MAKE install
 
 # Run tests
 if [ "$RUN_TESTS" = "yes" ]; then
+    cd tests
+
     # Allow core dumps
     ulimit -c unlimited
 
     # Add 'babeltrace' binary to PATH
-    chmod +x $BABEL_BINS/babeltrace
+    chmod +x "$BABEL_BINS/babeltrace"
     export PATH="$PATH:$BABEL_BINS"
 
     # Prepare tap output dirs
-    rm -rf $WORKSPACE/tap
-    mkdir -p $WORKSPACE/tap
-    mkdir -p $WORKSPACE/tap/unit
-    mkdir -p $WORKSPACE/tap/fast_regression
-    mkdir -p $WORKSPACE/tap/with_bindings_regression
-
-    cd $BUILD_PATH/tests
+    rm -rf "$WORKSPACE/tap"
+    mkdir -p "$WORKSPACE/tap"
+    mkdir -p "$WORKSPACE/tap/unit"
+    mkdir -p "$WORKSPACE/tap/fast_regression"
+    mkdir -p "$WORKSPACE/tap/with_bindings_regression"
 
     # Force the lttng-sessiond path to /bin/true to prevent the spawing of a
     # lttng-sessiond --daemonize on "lttng create"
@@ -244,43 +294,47 @@ if [ "$RUN_TESTS" = "yes" ]; then
 
     # Run 'unit_tests' and 'fast_regression' test suites for all configs except 'no-ust'
     if [ "$conf" != "no-ust" ]; then
-        prove --merge -v --exec '' - < $BUILD_PATH/tests/unit_tests --archive $WORKSPACE/tap/unit/ || true
-        prove --merge -v --exec '' - < $BUILD_PATH/tests/fast_regression --archive $WORKSPACE/tap/fast_regression/ || true
+        # Run 'unit_tests', 2.8 and up has a new test suite
+        if vergte "$PACKAGE_VERSION" "2.8"; then
+            make check
+            rsync -a --exclude 'test-suite.log' --include '*/' --include '*.log' --exclude='*'" $BUILD_PATH/tests/" "$WORKSPACE/tap"
+        else
+            prove --merge -v --exec '' - < "$BUILD_PATH/tests/unit_tests" --archive "$WORKSPACE/tap/unit/" || true
+            prove --merge -v --exec '' - < "$BUILD_PATH/tests/fast_regression" --archive "$WORKSPACE/tap/fast_regression/" || true
+        fi
     else
         # Regression is disabled for now, we need to adjust the testsuite for no ust builds.
-        echo "Testsuite disabled for 'no-ust'. See job configuration for more info."
+        echo "Tests disabled for 'no-ust'."
     fi
 
     # Run 'with_bindings_regression' test suite for 'python-bindings' config
     if [ "$conf" = "python-bindings" ]; then
-        prove --merge -v --exec '' - < $WORKSPACE/tests/with_bindings_regression --archive $WORKSPACE/tap/with_bindings_regression/ || true
+        prove --merge -v --exec '' - < "$WORKSPACE/tests/with_bindings_regression" --archive "$WORKSPACE/tap/with_bindings_regression/" || true
     fi
 
     # TAP plugin is having a hard time with .yml files.
-    rm -f $WORKSPACE/tap/unit/meta.yml
-    rm -f $WORKSPACE/tap/fast_regression/meta.yml
-    rm -f $WORKSPACE/tap/with_bindings_regression/meta.yml
+    find "$WORKSPACE/tap" -name "meta.yml" -exec rm -f {} \;
 
     # And also with files without extension, so rename all result to *.tap
-    find $WORKSPACE/tap/unit/ -type f -exec mv {} {}.tap \;
-    find $WORKSPACE/tap/fast_regression/ -type f -exec mv {} {}.tap \;
-    find $WORKSPACE/tap/with_bindings_regression/ -type f -exec mv {} {}.tap \;
+    find "$WORKSPACE/tap/" -type f -exec mv {} {}.tap \;
+
+    cd -
 fi
 
 # Cleanup
 $MAKE clean
 
 # Cleanup rpath in executables and shared libraries
-find $WORKSPACE/build/bin -type f -perm -0500 -exec chrpath --delete {} \;
-find $WORKSPACE/build/lib -name "*.so" -exec chrpath --delete {} \;
+find "$WORKSPACE/build/bin" -type f -perm -0500 -exec chrpath --delete {} \;
+find "$WORKSPACE/build/lib" -name "*.so" -exec chrpath --delete {} \;
 
 # Remove libtool .la files
-find $WORKSPACE/build/lib -name "*.la" -exec rm -f {} \;
+find "$WORKSPACE/build/lib" -name "*.la" -exec rm -f {} \;
 
 # Clean temp dir for dist build
 if [ "$build" = "dist" ]; then
-    cd $WORKSPACE
-    rm -rf $BUILD_PATH
+    cd "$WORKSPACE"
+    rm -rf "$BUILD_PATH"
 fi
 
 # EOF
This page took 0.025476 seconds and 4 git commands to generate.